export class MqttMessageError extends Error {
  constructor(msg : string) {
    super(msg)
  }
}

export class MqttMessage {
  private topic : string
  private message : object

  constructor(topic : string, inMessage : string, encapsulate: boolean = false, parsePayload: boolean = false) {
    this.topic = topic
    try {
      if (encapsulate) {
        let payload: string
        if (parsePayload) {
          payload = JSON.parse(inMessage)
        } else {
          payload = inMessage
        }
        this.message = {'topic': topic, 'payload': payload, 'ts': new Date()}
      } else {
        this.message = JSON.parse(inMessage)
      }
    } catch (e) {
      throw new MqttMessageError(`error while parsing message, ${e.toString()}`)
    } 
  }

  getTopic() : string {
    return this.topic
  }

  getMessage() : object {
    return this.message
  }
}
